#include <libgen.h>
#include <time.h>
#include "select-file.h"
#include "../box3.h"
#include "../barvy.h"
#include "../libw.h"
#include "../lib.h"

static void vymaz(WINDOW * win, int lines, int cols)
{
    int i, j;
    for (i = 0; i < lines; i++) {
	for (j = 0; j < cols; j++) {
	    mvwaddch2(win, i, j, ' ');
	}
    }
}

int selectFile(WINDOW * win, char *file, fileInfo * info, int ix)
{
    int i, j, lines, cols;
    char *t;
    int ch = '\0';

    wattron2(win, COLOR_PAIR(COLOR_FILE_MANAGER_HLAVNI));
    while (ch != '\n') {
	getmaxyx(win, lines, cols);
	if (lines != FM_LINES || cols != FM_COLS) {
	    wresize(win, FM_LINES, FM_COLS);
	    lines = FM_LINES;
	    cols = FM_COLS;
	}
	i = 0;
	if ((ix + 5) > (lines - 2)) {
	    i += (ix + 5 - (lines - 2));
	}
	vymaz(win, lines, cols);
	j = 3;
	wmove2(win, j, 0);
	if (info) {
	    while (info[i].path[0]) {
		if (!strcmp(basename(info[i].path), ".")) {
		    i++;
		    continue;
		}
		//wattroff2(win, COLOR_PAIR(COLOR_NAPOVEDA_NADPIS));
		if (i == ix)
		    wattron2(win, A_REVERSE);
		if (info[i].is_directory) {
		    //wattron2(win, COLOR_PAIR(COLOR_NAPOVEDA_NADPIS));
		}
		WPRINTW2(win, " %26.26s", basename(info[i].path));
		if (info[i].is_link) {
		    WPRINTW2(win, "  -> %11s        ", " ");
		} else if (info[i].is_directory) {
		    WPRINTW2(win, "/%15s        ", " ");
		} else {
		    WPRINTW2(win, "%16.2f KiB    ",
			     (float) info[i].stat.st_size / 1024);
		}
		t = ctime(&info[i].stat.st_mtime);
		t[strlen(t) - 1] = '\0';
		WPRINTW2(win, "%s", t);
		if (i == ix)
		    wattroff2(win, A_REVERSE);
		wmove2(win, ++j, 0);
		i++;
	    }
	} else {
	    wprintw2(win,
		     "  Nelze zobrazit obsah tohto adresáře.\n  Pokračujte klávesou <Enter>");
	    i = 1;
	}
	box3(win, ACS_VLINE, ACS_HLINE);
	wmove2(win, 1, 1);
	wprintw2(win, file);
	MVWPRINTW2(win, lines - 1, 2,
		   "k = konec, <Enter> = vybrat soubor, l = dolu, h,L = nahoru");
#ifdef _FM_TEST
	wrefresh2(win);
#else
	tiskni_dle_priority();
#endif
#ifdef _FM_TEST
	ch = wgetch2(stdscr);	// s win nefunguji KEY_* z nejakeho duvodu
#else
	ch = getch3();
#endif
	switch (ch) {
	case KEY_DOWN:
	case ' ':
	case 'l':
	    ix++;
	    if (ix < i)
		if (!strcmp(basename(info[ix].path), "."))
		    ix++;
	    break;
	case KEY_NPAGE:
	    ix += lines / 2;
	    if (ix < i)
		if (!strcmp(basename(info[ix].path), "."))
		    ix++;
	    break;
	case KEY_UP:
	case 'h':
	case 'L':
	    ix--;
	    if (ix > 0)
		if (!strcmp(basename(info[ix].path), "."))
		    ix--;
	    break;
	case KEY_PPAGE:
	    ix -= lines / 2;
	    if (ix > 0)
		if (!strcmp(basename(info[ix].path), "."))
		    ix--;
	    break;
	case 'k':
	    return -2;
	}
	if (ix < 0)
	    ix = 0;
	if (ix >= i)
	    ix = i - 1;
    }
    if (!info)
	return -1;
    return ix;
}
