/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor menu_funkce.c */

#include <ctype.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "strukturyw.h"
#include "struktury.h"
#include "lib.h"
#include "libw.h"
#include "barvy.h"
#include "windows.h"
#include "menu.h"

#define MAXVL  11               /* max vyber length: 6*lekce + 6*test; */
menu_vyber_lt vyber_lt[MAXVL];  /* extern */
unsigned int LEKCE = 0;         /* pocet skutecnych lekci; extern */
unsigned int TEST = 0;          /* pocet skutecnych testu; extern */
unsigned int LEKCER = 0;        /* prvni lekce na psani rychlosti; extern */
unsigned int TESTR = 0;         /* prvni test na psani rychlosti; extern */

int nacti_vyber_lt()
{
    short int i, j, k;
    static char opt[MAXVL][40];
    char temp[40];
    FILE *soubor;
    char *chyba_vyberu[] = { "  NEPODAILO SE NAST MENU!\n"
            "  (soubor ...napoveda/menu)  \n",
        "            < OK >"
    };

    if ((soubor = fopen(jmeno_menu(), "rt")) == NULL) {
        (void) button(chyba_vyberu, 2, 1, 5, 34, ((LINES - 5) / 2) - 2,
                      ((COLS - 34) / 2) - 1);
        return 1;
    }

    if (!fgets(temp, sizeof(temp) / sizeof(char) - 1, soubor)
        || sscanf(temp, "%u %u %u %u", &LEKCE, &TEST, &LEKCER,
                  &TESTR) != 4) {
        (void) button(chyba_vyberu, 2, 1, 5, 34, ((LINES - 5) / 2) - 2,
                      ((COLS - 34) / 2) - 1);
        return 1;
    }

    for (i = 0; i < MAXVL; i++) {
        j = 0;
        if (fgets(temp, sizeof(temp) / sizeof(char) - 1, soubor)) {
            j = sscanf(temp, "%c: %i %i", &vyber_lt[i].fce,
                       &vyber_lt[i].min, &vyber_lt[i].max);
        }
        if ((j != 3) || feof(soubor)) {
            if (i == 0) {
                /* prvni polozka musi obsahovat nejake hodnoty */
                (void) button(chyba_vyberu, 2, 1, 5, 34,
                              ((LINES - 5) / 2) - 2,
                              ((COLS - 34) / 2) - 1);
                return 1;
            }
            vyber_lt[i].fce = 'n';
            vyber_lt[i].min = -1;
            vyber_lt[i].max = -1;
            vyber_lt[i].ch = ' ';
            vyber_lt[i].opt = NULL;
            if (feof(soubor))
                break;
            continue;
        }

        memset(opt[i], '\0', sizeof(opt[i]) / sizeof(char));
        vyber_lt[i].opt = opt[i];
        j = k = 0;
        while (temp[j++]) {
            if (temp[j] == ' ')
                k++;
            if (k >= 3) {
                while (temp[j] && (temp[j] == ' '))
                    j++;
                strncpy(opt[i], temp + j,
                        sizeof(opt[i]) / sizeof(char) - 1);
                opt[i][strlen(opt[i]) - 1] = '\0';
                break;
            }
        }

        if (strlen(opt[i]) > 0) {
            for (j = 0; j < strlen(opt[i]) - 1; j++)
                if (opt[i][j] == '&') {
                    vyber_lt[i].ch = tolower(opt[i][j + 1]);
                    break;
                }
        } else
            vyber_lt[i].ch = ' ';

        /* kontrola spravnosti udaju */
        if (LEKCE > MAXLEKCE)
            LEKCE = MAXLEKCE;
        if (TEST >= MAXTEST)
            TEST = MAXTEST;
        if (LEKCER > LEKCE)
            LEKCER = LEKCE;
        if (TESTR > TEST)
            TESTR = TEST;

        switch (vyber_lt[i].fce) {
        case 'L':
            vyber_lt[i].fce = 'l';
        case 'l':
            if (vyber_lt[i].max > LEKCE)
                vyber_lt[i].max = LEKCE;
            break;
        case 'T':
            vyber_lt[i].fce = 't';
        case 't':
            if (vyber_lt[i].max > TEST)
                vyber_lt[i].max = TEST;
            break;
        }
        /*  konec kontroly spravnosti udaju */
    }                           /*(for (i = 0; i < 12; ... */
    fclose(soubor);

    j = 11;
    for (i = 0; i < MAXVL; i++) {
        option[i].navrat = (enum_menu) i;
        if ((vyber_lt[i].min > 0) && (vyber_lt[i].max >= vyber_lt[i].min)) {
            option[i].opt = vyber_lt[i].opt;
            option[i].ch = vyber_lt[i].ch;
            switch (vyber_lt[i].fce) {
            case 'l':
                option[i].fce = m_lekce;
                break;
            case 't':
                option[i].fce = m_test;
                break;
            default:
                option[i].fce = NULL;
                break;
            }
        } else {
            option[i].opt = NULL;
            option[i].ch = ' ';
            option[i].fce = NULL;
            j = i;
        }
    }
    if (j > 3 && !option[j - 1].opt) {
        /* jen jednu polozku chci prazdnou a pod ni Klavesnici */
        while (j > 1 && (!option[j - 2].opt))
            j--;
    }
    option[j].opt = "V&oln texty";
    option[j].ch = 'o';
    option[j].navrat = e_vt;

    return 0;
}

/* ----------------------------------------------------------------- */
int m_lekce(int cislo, type_uziv * slozka, type_nastaveni * nastaveni)
{
    int i;
    type_informace info;

#ifdef PSANIPROFI
    vymaz_okno(sub_informace);
#endif
    for (i = vyber_lt[cislo].min; i <= vyber_lt[cislo].max; i++) {
        info = informace_o_lekcich(i, slozka);
        if (strcmp(info.nove_pismena, "")) {
            MVWPRINTW2(sub_informace, i - vyber_lt[cislo].min + 1, 1,
                       "%02i:%s", i, info.nove_pismena);
        } else {
            MVWPRINTW2(sub_informace, i - vyber_lt[cislo].min + 1, 1,
                       "%02i:%03i h.", i, info.rychlost[0]);
        }

    }
    mvwprintw2(sub_informace, i - vyber_lt[cislo].min + 1, 1,
               "                 ");
    obnov_informace();
    return 0;
}

int m_test(int cislo, type_uziv * slozka, type_nastaveni * nastaveni)
{
    int i;
    for (i = vyber_lt[cislo].min; i <= vyber_lt[cislo].max; i++)
        MVWPRINTW2(sub_informace, i - vyber_lt[cislo].min + 1, 1,
                   "Test  %02i", i);

    obnov_informace();
    return 0;
}

int m_jmeno(int cislo, type_uziv * slozka, type_nastaveni * nastaveni)
{
    obnov_hlavni();
    return zadej_jmeno(slozka, nastaveni, cislo);
}

int m_heslo(int cislo, type_uziv * slozka, type_nastaveni * nastaveni)
{
    obnov_hlavni();
    return zadej_heslo(slozka, nastaveni, cislo);
}

/*-----------------------------------------------------------------------*/
int aktualni_radek(int ch, int radka)
{
    if (ch == KEY_DOWN || ch == '\n') {
        if (radka < OPT - 1)
            do {
                radka++;
            }
            while (!option[radka].opt);
        else
            (radka) = 0;
    } else if (ch == KEY_UP)
        do {
            (radka)--;
        }
        while (!option[radka].opt);

    return radka;
}

int zadej_jmeno(type_uziv * slozka, type_nastaveni * nastaveni, int radka)
{
    char jmeno[UZ_LEN];
    int ch;
    int sloupec = 0;

    for (ch = 1; ch < 5; ch++)
        if (radka > (POCRADEK * ch))
            sloupec++;

    strncpy(jmeno, slozka->jmeno, UZ_LEN);
    ch = zadej_text(jmeno, UZ_LEN, POS + radka - sloupec * POCRADEK + 5,
                    (sloupec + 1) * POS2 + RCSINF + 1, 1, 0);

    if (ch == '\n') {
        strncpy(slozka->jmeno, jmeno,
                sizeof(slozka->jmeno) / sizeof(slozka->jmeno[0]));
        obnov_nadpis1(slozka, nastaveni);

        if (uloz_slozku(slozka))
            print_hl(2, "CHYBA: data se nepodailo uloit do souboru ",
                     jmeno_souboru());
        else
            print_hl(1, "Jmno je spn zmnno !");
    }
    return aktualni_radek(ch, radka);
}

int zadej_heslo(type_uziv * slozka, type_nastaveni * nastaveni, int radka)
{
    char pomocn[2][PW_LEN];
    int ch;
    int sloupec = 0;

    for (ch = 1; ch < 5; ch++)
        if (radka > (POCRADEK * ch))
            sloupec++;

    memset(pomocn[0], '\0', PW_LEN);
    ch = zadej_text(pomocn[0], PW_LEN,
                    POS + radka - sloupec * POCRADEK + 5,
                    (sloupec + 1) * POS2 + RCSINF + 1, 1, 1);

    if ((ch != '\n')) {
        if (strcmp(pomocn[0], ""))
            print_hl(1,
                     "Heslo se nezmnilo! Heslo se zmn jen po ukonen <ENTREM>");
        return aktualni_radek(ch, radka);
    }

    if (strcmp(pomocn[0], "")) {

        print_hl(1, "Zadejte heslo pro kontrolu znovu");
        memset(pomocn[1], '\0', PW_LEN);
        ch = zadej_text(pomocn[1], PW_LEN,
                        POS + radka - sloupec * POCRADEK + 5,
                        (sloupec + 1) * POS2 + RCSINF + 1, 1, 1);
        if ((ch != '\n')) {
            print_hl(1,
                     "Heslo se nezmnilo! Heslo se zmn jen po ukonen <ENTREM>");
            return aktualni_radek(ch, radka);
        }
        if (strcmp(pomocn[0], pomocn[1])) {
            print_hl(1,
                     "Sorry, ale heslo nebylo zadno stejn! Teba pt ...");
            return aktualni_radek(ch, radka);
        }
    }
    strncpy(slozka->heslo, pomocn[0],
            sizeof(slozka->heslo) / sizeof(slozka->heslo[0]));
    sifruj(slozka->heslo, slozka->heslo_I);
    obnov_nadpis1(slozka, nastaveni);

    if (uloz_slozku(slozka))
        print_hl(2, "CHYBA: data se nepodailo uloit do souboru ",
                 jmeno_souboru());
    else {
        if (strcmp(pomocn[0], ""))
            print_hl(1, "Heslo spn zmnno ! Dejte si pozor na to\n"
                     "jakou mte nastavenou znakovou sadu klvesnice.");
        else
            print_hl(1, "Heslo bylo spn odstranno!");
    }
    return aktualni_radek(ch, radka);
}
